#====
# Manager Class
#====

import os, sys, math, random
import pygame
from pygame.locals import *
from equates import *
from helpers import *

class EnemyManagerSprite(pygame.sprite.Sprite):

	def __init__(self,position):	
		pygame.sprite.Sprite.__init__(self)				
		self.image, self.rect = load_image('manager.png',None,position)
		if self.rect == None:
			self.rect = self.image.get_rect()
		self.src_image = self.image
		self.max_health = MANAGER_HEALTH_MAX
		self.current_health = self.max_health
		self.speed = MANAGER_START_SPEED
		self.position = position
		self.direction = random.randrange(0,360)
		self.alert_radius = 150
		self.previous_direction_increment = 0
		self.death_sound = load_sound('enemy_manager_death.ogg')

	def update(self,deltat,player_position):
		# SIMULATION	
		
		"""
		
		# .. Direction Change
		player_x, player_y = player_position
		x,y = self.position
		intended_direction = 0		
		
		# .. if Player is inside the Alert Radius, turn towards them
		if player_x <= x+self.alert_radius and player_x >= x-self.alert_radius and player_y <= y+self.alert_radius and player_y >= y-self.alert_radius:		
			#-----
			# Manager AI
			# .. This definitely needs to be ecapsulated somewhere, in a function maybe for all "Objects" in case they want to chase the Player, or some position
			#-----
			a_len = int(math.fabs(player_x-x))
			b_len = int(math.fabs(player_y-y))
			c_len = math.sqrt((a_len*a_len) + (b_len*b_len))
			if a_len < b_len:
				rads = math.asin(a_len/c_len)
			else:
				rads = math.asin(b_len/c_len)
				
			#rads = math.asin(a_len/c_len)	
			
			degrees = math.degrees(rads)

			# .. now the joy of working out the actual direction, because we've only just managed to work out 
			#			the degrees of the shortest side
			if player_x > x:
				if player_y > y:
					if a_len < b_len:
						intended_direction = 180 - degrees
					else:	
						intended_direction = 90 + degrees						
				else:
					if a_len < b_len:
						intended_direction = degrees
					else:
						intended_direction = 90 - degrees
			else:
				if player_y > y:
					if a_len < b_len:
						intended_direction = 180 + degrees
					else:	
						intended_direction = 270 - degrees
				else:
					if a_len < b_len:
						intended_direction = 360 - degrees
					else:
						intended_direction = 270 + degrees					
			if (self.direction > intended_direction - 15) and (self.direction < intended_direction + 15):
				nothing = 1
			else:
				if (self.direction >= 0) and (self.direction < 180):
					if (intended_direction > self.direction) and (intended_direction <= self.direction + 180):
						self.direction -= MANAGER_TURN_SPEED
					else:
						self.direction += MANAGER_TURN_SPEED
				else:
					if (intended_direction <= self.direction) and (intended_direction > self.direction - 180):
						self.direction += MANAGER_TURN_SPEED
					else:
						self.direction -= MANAGER_TURN_SPEED
						
			if (self.direction > 360):
				self.direction -= 360
			elif (self.direction < 0):
				self.direction += 360
				
			#self.direction = intended_direction

			#print("intended: "+str(intended_direction)+", self: "+str(self.direction))
			
			#self.direction = intended_direction
			
		#if random.randrange(1,10) > 5:
		#	self.direction += random.randrange(0,90)
		# .. update Position
		
		"""
		
		if random.randrange(1,20) > 15:
			if (self.previous_direction_increment >= 0) and (random.randrange(1,10) > 3):
				self.direction += MANAGER_TURN_SPEED
				self.previous_direction_increment = MANAGER_TURN_SPEED
			else:
				self.direction -= MANAGER_TURN_SPEED
				self.previous_direction_increment = -MANAGER_TURN_SPEED
		
		x,y = self.position
		rad = self.direction * math.pi / 180
		x += -self.speed*math.sin(rad)
		y += -self.speed*math.cos(rad)
		# .. boundary check
		if x < 0: x = MAX_XPOS
		elif x > MAX_XPOS: x = 0
		if y < 0: y = MAX_YPOS
		elif y > MAX_YPOS: y = 0
		# .. continue
		self.position = (x,y)
		
		#print("position: "+str(self.position)+", rad: "+str(rad)+", intended: "+str(intended_direction)+", self: "+str(self.direction))
		
		self.image = pygame.transform.rotate(self.src_image,self.direction)
		self.rect = self.image.get_rect()
		self.rect.center = self.position
		
	def draw_health(self,display):
		font = pygame.font.Font(DEFAULT_FONT,8)
		health_percentage = int(float(self.current_health) / float(self.max_health) * 100)
		text = font.render(str(health_percentage)+"%",1,(255,255,255),(0,0,0))
		textpos = self.rect.bottomleft
		textpos = (textpos[0],textpos[1]+5)
		display.blit(text,textpos)
