#====
# VisitingSuits Class
#====

import os, sys, math, random
import pygame
from pygame.locals import *
from equates import *
from helpers import *

class EnemyVisitingSuitsSprite(pygame.sprite.Sprite):

	def __init__(self,position):	
		pygame.sprite.Sprite.__init__(self)				
		self.image, self.rect = load_image('visitingsuits.png',None,position)
		if self.rect == None:
			self.rect = self.image.get_rect()
		self.src_image = self.image
		self.max_health = VISITINGSUITS_HEALTH_MAX
		self.current_health = self.max_health
		self.speed = VISITINGSUITS_START_SPEED
		self.position = position
		self.direction = random.randrange(0,360)
		self.alert_radius = 150
		self.previous_direction_increment = 0
		self.death_sound = load_sound('enemy_visitingsuits_death.ogg')

	def update(self,deltat,player_position):
		# SIMULATION	
		
		# .. Direction Change
		player_x, player_y = player_position
		x,y = self.position
		intended_direction = 0
		
		if random.randrange(1,20) > 15:
			if (self.previous_direction_increment >= 0) and (random.randrange(1,10) > 3):
				self.direction += VISITINGSUITS_TURN_SPEED
				self.previous_direction_increment = VISITINGSUITS_TURN_SPEED
			else:
				self.direction -= VISITINGSUITS_TURN_SPEED
				self.previous_direction_increment = -VISITINGSUITS_TURN_SPEED
		
		rad = self.direction * math.pi / 180
		x += -self.speed*math.sin(rad)
		y += -self.speed*math.cos(rad)
		# .. boundary check
		if x < 0: x = MAX_XPOS
		elif x > MAX_XPOS: x = 0
		if y < 0: y = MAX_YPOS
		elif y > MAX_YPOS: y = 0
		# .. continue
		self.position = (x,y)
		
		#print("position: "+str(self.position)+", rad: "+str(rad)+", intended: "+str(intended_direction)+", self: "+str(self.direction))
		
		self.image = pygame.transform.rotate(self.src_image,self.direction)
		self.rect = self.image.get_rect()
		self.rect.center = self.position
		
	def draw_health(self,display):
		font = pygame.font.Font(DEFAULT_FONT,8)
		health_percentage = int(float(self.current_health) / float(self.max_health) * 100)
		text = font.render(str(health_percentage)+"%",1,(255,255,255),(0,0,0))
		textpos = self.rect.bottomleft
		textpos = (textpos[0],textpos[1]+5)
		display.blit(text,textpos)