#====
# Equates
#====

DEFAULT_FONT = 'freesansbold.ttf'

TOP_LEFT = 1
TOP_RIGHT = 2
BOTTOM_LEFT = 3
BOTTOM_RIGHT = 4

WINDOW_WIDTH = 1024
WINDOW_HEIGHT = 768
MAX_XPOS = 1024
MAX_YPOS = 768

STATE_INIT = 1
STATE_BEGIN = 2
STATE_PLAY = 3
STATE_END = 4
STATE_EXIT = 5
STATE_FINISHED = 6
STATE_EPILOGUE = 7

PLAYERSTATE_DEAD = 1
PLAYERSTATE_ALIVE = 2
PLAYERSTATE_DYING = 3
PLAYERSTATE_BIRTH = 4

PLAYER_START_XPOS = WINDOW_WIDTH/2
PLAYER_START_YPOS = WINDOW_HEIGHT/2
PLAYER_BASE_LEFT = PLAYER_START_XPOS - 50
PLAYER_BASE_RIGHT = PLAYER_START_XPOS + 50
PLAYER_BASE_WIDTH = PLAYER_BASE_RIGHT - PLAYER_BASE_LEFT
PLAYER_BASE_TOP = PLAYER_START_YPOS - 50
PLAYER_BASE_BOTTOM = PLAYER_START_YPOS + 50
PLAYER_BASE_HEIGHT = PLAYER_BASE_BOTTOM - PLAYER_BASE_TOP

PLAYER_START_HEALTH = 200
PLAYER_START_SPEED = 0

SCORE_MANAGER = 10
SCORE_VISITINGSUITS = 50
SCORE_UPPERMANAGEMENT = 100
SCORE_CEO = 500
SCORE_BOARDMEMBER = 1000
SCORE_SYCOPHANT = 250

SCORE_WEAPON_ONE = -3
SCORE_WEAPON_TWO = -100
#SCORE_WEAPON_THREE = -50
SCORE_PLAYER_DEATH = -250

MAX_ENEMIES_ALIVE = 10

ENEMY_MANAGER = 1
ENEMY_VISITINGSUITS = 2
ENEMY_UPPERMANAGEMENT = 3
ENEMY_CEO = 4
ENEMY_BOARDMEMBER = 5
ENEMY_SYCOPHANT = 6

LEVELS_MAX = 10
LEVEL_ONE_EXP = 500 #2000
LEVEL_TWO_EXP = 3500 #5000
LEVEL_THREE_EXP = 6000 #10000
LEVEL_FOUR_EXP = 10000 #20000
LEVEL_FIVE_EXP = 20000 #45000
LEVEL_SIX_EXP = 32000 #90000
LEVEL_SEVEN_EXP = 45000 #200000
LEVEL_EIGHT_EXP = 58000 #450000
LEVEL_NINE_EXP = 70000 #900000
LEVEL_TEN_EXP = 125000 #1500000

WORLD_TOP = 50
WORLD_BOTTOM = WINDOW_HEIGHT-50
WORLD_LEFT = 50
WORLD_RIGHT = WINDOW_WIDTH-50

WEAPON_ONE = 1
WEAPON_TWO = 2
WEAPON_THREE = 3
WEAPON_FOUR = 4
WEAPON_FIVE = 5

WEAPON_LIFESPAN_VERYSHORT = 10
WEAPON_LIFESPAN_SHORT = 15
WEAPON_LIFESPAN_MEDIUM = 30
WEAPON_LIFESPAN_LONG = 45
WEAPON_LIFESPAN_VERYLONG = 100

WEAPON_ONE_SPEED = 25
WEAPON_ONE_DAMAGE = 100
WEAPON_ONE_MULTI = 1
WEAPON_ONE_THROUGH = 0
WEAPON_ONE_LEVEL = 0

WEAPON_TWO_SPEED = 0
WEAPON_TWO_DAMAGE = 1000
WEAPON_TWO_MULTI = 1
WEAPON_TWO_THROUGH = 0
WEAPON_TWO_LEVEL = 2

WEAPON_THREE_SPEED = 15
WEAPON_THREE_DAMAGE = 200
WEAPON_THREE_MULTI = 1
WEAPON_THREE_THROUGH = 0
WEAPON_THREE_LEVEL = 7
WEAPON_THREE_FIRING_TIMER = 1500

WEAPON_THREE_BASE_DISTANCE = 50

WEAPON_TWO_SHRAPNEL_SPEED = 15

WEAPON_TASK_SPEED = 10
WEAPON_TASK_DAMAGE = 50
WEAPON_TASK_MULTI = 1
WEAPON_TASK_THROUGH = 0

WEAPON_MAGICWAND_SPEED = 5
WEAPON_MAGICWAND_DAMAGE = 150

WEAPON_CREDITCARD_SPEED = 5
WEAPON_CREDITCARD_DAMAGE = 300

WEAPON_TURN_SPEED = 5

WEAPON_MAX_LIFESPAN = 50
WEAPON_MAX_DAMAGE = 2000
WEAPON_MAX_MULTI = 5
WEAPON_MAX_THROUGH = 5

MANAGER_HEALTH_MAX = 200
MANAGER_START_SPEED = 1
MANAGER_TURN_SPEED = 5
MANAGER_DAMAGE = 20
MANAGER_LEVEL = 0

VISITINGSUITS_HEALTH_MAX = 500
VISITINGSUITS_START_SPEED = 3
VISITINGSUITS_TURN_SPEED = 5
VISITINGSUITS_DAMAGE = 75
VISITINGSUITS_LEVEL = 1

UPPERMANAGEMENT_HEALTH_MAX = 1000
UPPERMANAGEMENT_START_SPEED = 2
UPPERMANAGEMENT_TURN_SPEED = 5
UPPERMANAGEMENT_FIRE_TIMER = 5000
UPPERMANAGEMENT_DAMAGE = 110
UPPERMANAGEMENT_LEVEL = 3

CEO_HEALTH_MAX = 2000
CEO_START_SPEED = 4
CEO_TURN_SPEED = 5
CEO_FIRE_TIMER = 5000
CEO_DAMAGE = 180
CEO_LEVEL = 6

BOARDMEMBER_HEALTH_MAX = 4000
BOARDMEMBER_START_SPEED = 6
BOARDMEMBER_TURN_SPEED = 5
BOARDMEMBER_FIRE_TIMER = 5000
BOARDMEMBER_DAMAGE = 350
BOARDMEMBER_LEVEL = 9

SYCOPHANT_HEALTH_MAX = 200
SYCOPHANT_START_SPEED = 3
SYCOPHANT_TURN_SPEED = 5
SYCOPHANT_LIFESPAN = 45
SYCOPHANT_DAMAGE = 35

SYCOPHANT_CHILD_SPEED = 15
SYCOPHANT_CHILD_DAMAGE = 500

BOSS_HEALTH_MAX = 75000
BOSS_START_SPEED = 5
BOSS_TURN_SPEED = 5
BOSS_LEVEL = 10
BOSS_DAMAGE = 1000
BOSS_WEAPON_FIRE_TIMER = 5000
BOSS_WEAPON_TASK_DAMAGE = 220
BOSS_WEAPON_MAGICWAND_DAMAGE = 360
BOSS_WEAPON_CREDITCARD_DAMAGE = 700
BOSS_RANDOM_CALL_TIMER = 2000

POWERUP_START_LIFESPAN = 50

POWERUP_LIFESPAN = 1
POWERUP_DAMAGE = 2
POWERUP_MULTI = 3
POWERUP_THROUGH = 4
POWERUP_HEALTH = 5
POWERUP_COUNT = 6
POWERUP_MAXHEALTH = 7

POWERUP_LIFESPAN_VALUE = 1
POWERUP_DAMAGE_VALUE = 15
POWERUP_MULTI_VALUE = 1
POWERUP_THROUGH_VALUE = 1
POWERUP_HEALTH_VALUE = 100