# HELPERS .. Kind of like a Tools DLL

import os, sys, math
import pygame
from pygame.locals import *
from equates import *
from vec2d import *

def load_image(name, colorkey=None, position=(0,0)):
	fullname = os.path.join('data','images')
	fullname = os.path.join(fullname,name)
	try:
		image = pygame.image.load(fullname)   #.convert_alpha()
	except pygame.error, message:
		print 'Cannot load image:', fullname
		raise SystemExit, message
	# image key stuff
	image = image.convert()
	"""
	if colorkey is not None:
		if colorkey is -1:
			colorkey = image.get_at((0,0))
		image.set_colorkey(colorkey,RLEACCEL)
	"""
	# .. Okay, because I stuffed up, always set this to black here (instead of passing it)
	image.set_colorkey((0,0,0),RLEACCEL)
	# position logic
	rect = image.get_rect()
	xpos = position[0] - rect.width / 2
	ypos = position[1] - rect.height / 2
	rect = pygame.Rect(xpos,ypos,rect.width,rect.height)
	# return
	return image, rect

def load_sound(name):
	fullname = os.path.join('data','sounds')
	fullname = os.path.join(fullname,name)

	class NoneSound:
		def play(self): pass
	if not pygame.mixer:
		return NoneSound()
	try:
		sound = pygame.mixer.Sound(fullname)
	except pygame.error, message:
		print 'Cannot load sound:', wav
		raise SystemExit, message
	return sound	
	
def get_bezier_base_points(origin_point,origin_direction,dest_point):
	points = [origin_point,0,0,dest_point]

	# .. Origin Point
	x = origin_point.x
	y = origin_point.y
	speed = 10
	#for i in range(1,100):
	rad = origin_direction * math.pi / 180
	x += -speed*math.sin(rad)
	y += -speed*math.cos(rad)
	if x < 0: x = MAX_XPOS
	elif x > MAX_XPOS: x = 0
	if y < 0: y = MAX_YPOS
	elif y > MAX_YPOS: y = 0
	points[1] = vec2d(x,y)

	# .. Destination Point
	x = dest_point.x
	y = dest_point.y
	speed = 10
	#for i in range(1,100):
	rad = origin_direction * math.pi / 180
	x += -speed*math.sin(rad)
	y += -speed*math.cos(rad)
	if x < 0: x = MAX_XPOS
	elif x > MAX_XPOS: x = 0
	if y < 0: y = MAX_YPOS
	elif y > MAX_YPOS: y = 0
	points[2] = vec2d(x,y)
	
	return points
	
def get_area(origin_x,origin_y,dest_x,dest_y):
	if (dest_x < origin_x) and (dest_y < origin_y):
		return TOP_LEFT
	elif (dest_x < origin_x) and (dest_y >= origin_y):
		return TOP_RIGHT
	elif (dest_x >= origin_x) and (dest_y < origin_y):
		return BOTTOM_LEFT
	elif (dest_x >= origin_x) and (dest_y >= origin_y):
		return BOTTOM_RIGHT
		
def get_next_point(position,direction,speed):
	x,y = position
	rad = direction * math.pi / 180
	x += -speed*math.sin(rad)
	y += -speed*math.cos(rad)
	# .. boundary check
	if x < 0: x = MAX_XPOS
	elif x > MAX_XPOS: x = 0
	if y < 0: y = MAX_YPOS
	elif y > MAX_YPOS: y = 0
	
	return x,y

def get_opposite_direction(direction):
	opp_dir = 0
	if direction >= 180:
		opp_dir = direction - 180
	else:
		opp_dir = direction + 180
		
	return opp_dir