#====
# Weapon Magic Wand Class
#====

import os, sys, math
import pygame
from pygame.locals import *
from equates import *
from helpers import *

class WeaponMagicWandSprite(pygame.sprite.Sprite):

	def __init__(self,position,direction,lifespan):
		pygame.sprite.Sprite.__init__(self)				
		self.image, self.rect = load_image('weapon_magicwand.png',None,position)
		if self.rect == None:
			self.rect = rect
		self.position = position
		self.direction = direction
		self.speed = WEAPON_MAGICWAND_SPEED
		self.lifespan = lifespan
		self.age = 0
		self.through = 0
		self.last_enemy = 0
		
	def update(self,deltat):
		# .. Age Check
		self.age += 1
		if self.age == self.lifespan:
			self.kill()
		# POSITIONING
		
		x,y = self.position
		rad = self.direction * math.pi / 180
		x += -self.speed*math.sin(rad)
		y += -self.speed*math.cos(rad)
		# .. boundary check
		if x < 0: x = MAX_XPOS
		elif x > MAX_XPOS: x = 0
		if y < 0: y = MAX_YPOS
		elif y > MAX_YPOS: y = 0
		
		# .. continue
		self.position = (x,y)
		self.rect = self.image.get_rect()
		self.rect.center = self.position
		
	def set_lifespan(self,span):
		self.lifespan = span