#====
# Weapon Three Base Class
#====

import os, sys, math, random
import pygame
from pygame.locals import *
from equates import *
from helpers import *
from weapon_three import *

class WeaponThreeBaseSprite(pygame.sprite.Sprite):

	def __init__(self,position):
		pygame.sprite.Sprite.__init__(self)				
		self.image, self.rect = load_image('weapon_three_base.png',None,position)
		self.src_image = self.image
		if self.rect == None:
			self.rect = rect
		self.position = position
		self.firing_timer = 0
		self.weapon_three_sound = load_sound('weapon_three.ogg')
		
	def update(self,deltat,position,direction,weapon_three_group,weapon_multi_value):
		# .. Init
		self.firing_timer += deltat
		# .. Position
		self.position = position
		self.image = pygame.transform.rotate(self.src_image,direction)
		self.rect = self.image.get_rect()
		self.rect.center = self.position
		# .. Fire?
		if self.firing_timer >= WEAPON_THREE_FIRING_TIMER:
			self.firing_timer = 0
			opp_dir = get_opposite_direction(direction)
			max_left_dir = opp_dir - 60
			max_right_dir = opp_dir + 60
			new_dir = random.randint(max_left_dir,max_right_dir)
			# .. Add Weapon "Projectiles"
			weapon_three_group.add(WeaponThreeSprite(self.position,new_dir,WEAPON_LIFESPAN_MEDIUM))
			self.weapon_three_sound.play()			
			"""
			angle_delta = 0
			for i in range(1,weapon_multi_value):
				weapon_three_group.add(WeaponThreeSprite(self.position,new_dir+angle_delta,WEAPON_LIFESPAN_MEDIUM))
				self.weapon_three_sound.play()
				if angle_delta >= 0:
					angle_delta = -(i+1*5)
				else:
					angle_delta = i+1*5
			"""