#====
# Weapon Two Class
#====

import os, sys, math
import pygame
from pygame.locals import *
from equates import *
from helpers import *

class WeaponTwoShrapnelSprite(pygame.sprite.Sprite):
	def __init__(self,position,direction,lifespan):
		pygame.sprite.Sprite.__init__(self)
		self.image, self.rect = load_image('weapon_two_shrapnel.png',None,position)
		if self.rect == None:
			self.rect = rect
		self.position = position
		self.direction = direction
		self.speed = WEAPON_TWO_SHRAPNEL_SPEED
		self.lifespan = lifespan
		self.age = 0

	def update(self,deltat):	
		# .. Life Check
		self.age += 1
		if self.age == self.lifespan:
			self.kill()
		# .. Calc New Position
		x,y = self.position
		rad = self.direction * math.pi / 180
		x += -self.speed*math.sin(rad)
		y += -self.speed*math.cos(rad)
		# .. boundary check
		if x < 0: x = MAX_XPOS
		elif x > MAX_XPOS: x = 0
		if y < 0: y = MAX_YPOS
		elif y > MAX_YPOS: y = 0
		# .. continue
		self.position = (x,y)		
		self.rect = self.image.get_rect()
		self.rect.center = self.position		
		
class WeaponTwoSprite(pygame.sprite.Sprite):

	def __init__(self,position,direction,lifespan):
		pygame.sprite.Sprite.__init__(self)				
		self.image, self.rect = load_image('weapon_two.png',None,position)
		if self.rect == None:
			self.rect = rect
		self.position = position
		self.direction = direction
		self.speed = WEAPON_TWO_SPEED
		self.lifespan = lifespan
		self.age = 0
		self.through = 0
		self.timer_sound = load_sound('weapon_timer.ogg')
		self.timer_sound_played = 0
		self.detonate_sound = load_sound('weapon_detonate.ogg')
		
	def update(self,deltat,shrapnel_group):
		# .. Life Check
		self.age += 1
		# .. Detonate?
		if self.age == self.lifespan:
			self.detonate(shrapnel_group)
			self.kill()
		elif self.age >= self.lifespan-20 and self.timer_sound_played == 0:
			self.timer_sound_played = 1
			self.timer_sound.play()
		# Calc New Position
		x,y = self.position
		rad = self.direction * math.pi / 180
		x += -self.speed*math.sin(rad)
		y += -self.speed*math.cos(rad)
		# .. boundary check
		if x < 0: x = MAX_XPOS
		elif x > MAX_XPOS: x = 0
		if y < 0: y = MAX_YPOS
		elif y > MAX_YPOS: y = 0
		# .. continue
		self.position = (x,y)		
		self.rect = self.image.get_rect()
		self.rect.center = self.position
		
	def set_lifespan(self,span):
		self.lifespan = span
		
	def detonate(self,shrapnel_group):
		self.detonate_sound.play()
		pos = 0
		while pos <= 360:
			shrapnel_group.add(WeaponTwoShrapnelSprite(self.position,pos,WEAPON_LIFESPAN_SHORT))
			pos += 30